;============================================
; Test Bed
;
;============================================

.386
.model flat, stdcall
option casemap :none


.nolist
	include \techstuff\masm32\include\windows.inc
	include \techstuff\masm32\include\user32.inc
	include \techstuff\masm32\include\kernel32.inc
	include \techstuff\masm32\include\gdi32.inc
	include \techstuff\masm32\include\comctl32.inc

	includelib \techstuff\masm32\lib\gdi32.lib
	includelib \techstuff\masm32\lib\user32.lib
	includelib \techstuff\masm32\lib\kernel32.lib
	includelib \techstuff\masm32\lib\Comctl32.lib
	includelib \techstuff\masm32\lib\comdlg32.lib
	includelib \techstuff\masm32\lib\shell32.lib
	includelib \techstuff\masm32\lib\oleaut32.lib
	includelib \techstuff\masm32\lib\ole32.lib
	includelib \techstuff\masm32\lib\msvcrt.lib
.list


;============================================
; Defines, macros, prototypes, etc.
;============================================

$ST	STRUCT						;Static text structure
  X		DD ?
  Y		DD ?
  w		DD ?
  h		DD ?
  text		DD ?	
  ID		DD ?
$ST	ENDS

;============================================
; Macro to declare static-text structures:
;============================================
$defStatTxt	MACRO tname, txt, x, y, w, h, ID
LOCAL	sname

sname		DB &txt, 0				;Declare the string
tname		$ST <x, y, w, h, OFFSET sname, ID>	;Declare the structure
		ENDM

$CW	STRUCT						;Child window structure
  ID		DD ?
  text		DD ?
  X		DD ?
  Y		DD ?
  handle	DD ?
$CW	ENDS

;============================================
; Macro to declare child-window structures:
;============================================
$defChildWin	MACRO cname, ID, x, y, txt
LOCAL	sname

sname		DB &txt, 0
cname		$CW <ID, OFFSET sname, x, y>
		ENDM


WinMain			PROTO :DWORD
CenterWindow		PROTO :DWORD, :DWORD
CreateStaticText	PROTO :DWORD
CreateMobileWin		PROTO :DWORD

$WindowWidth		EQU 700
$WindowHeight		EQU 300

$SBX			EQU 0
$SBY			EQU 240
$SBWidth		EQU 600
$SBHeight		EQU 40

$childWidth		EQU 150
$childHeight		EQU 25

$CB_X			EQU 50
$CB_Y			EQU 10
$CBwidth		EQU 250
$CBheight		EQU 250
$CBID			EQU 1111

;===== IDs: =====
$statusbarID		EQU 1212

;===== Window styles: =====
$mainWinAttrs		EQU WS_OVERLAPPEDWINDOW + WS_CLIPCHILDREN
$CBattrs		EQU CBS_DROPDOWNLIST + CBS_HASSTRINGS + CBS_SORT + WS_CHILD + WS_OVERLAPPED + WS_VSCROLL + WS_VISIBLE + ES_MULTILINE
$STattrs		EQU WS_CHILD + WS_VISIBLE + SS_LEFT
$SB_attrs		EQU WS_CHILD or WS_VISIBLE
$childAttrs		EQU WS_BORDER + WS_CHILD + WS_VISIBLE

$bkRED			EQU 254
$bkGRN			EQU 243
$bkBLUE			EQU 199


;============================================
; DATA
;============================================
.data

firstthing		dd $

WindowHandle		HWND ?
InstanceHandle		HWND ?
CBHandle		HWND ?
StatusHandle		HWND ?
ChildHandle		HWND ?
ChildHandle1		HWND ?
ChildHandle2		HWND ?

SBheight		DD ?

MyLF			LOGFONT <>

PrevRect		RECT <>

BkColor			DD $bkRED + $bkGRN SHL 8 + $bkBLUE SHL 16

WindowClassName		DB "Testbed", 0
WindowDisplayName	DB "Test Bed", 0
CBclassName		DB "cOmBoBoX", 0		;Let's use cRaZyCaSe!
STclassName		DB "STATIC", 0
MWclassName		DB "MobileWin", 0

$defStatTxt		@ST_Font, "Font:", 10, 14, 40, 20, 401

$defChildWin		@CW_George, 1100, 50, 100, "George"
$defChildWin		@CW_Lucy, 1101, 50, 200, "Lucy"
$defChildWin		@CW_Bizarre, 1102, 250, 100, "Bizarre"
$defChildWin		@CW_Q, 1103, 250, 200, "?????"
$defChildWin		@CW_Jungle, 1104, 500, 100, "Jungle"
$defChildWin		@CW_Pop, 1105, 500, 200, "pop"

ChildWinList		DD @CW_George, @CW_Lucy, @CW_Bizarre, @CW_Q, @CW_Jungle, @CW_Pop, 0

DragFlag		DB FALSE
MouseCaptured		DB FALSE

StatusMessage		DB "Mouse: X: "
StatusXpos		DB "#### Y: "
StatusYpos		DB "####"
NullString		DB 0

debugmsg1		DB "Window created OK.", 0
debugmsg2		DB "In window proc", 0
debugmsg3		DB "Window handle is NULL!", 0
debugmsg4		DB "RegisterClass failed!", 0
debugmsg5		DB "CB creation failed!", 0
debugmsg6		DB "In Enum callback", 0
debugmsg7		DB "CreateWindowEx failed!", 0
debugmsg8		DB "x is %d", 0
debugmsg9		DB "text is %s", 0
debugmsg10		DB "addr is %08lX", 0
debugmsg11		DB "start of data: %08lX", 0
debugmsg12		DB "addr of @ST_Font: %08lX", 0

testtag db "Test!", 0
mousedownmsg db "Mouse button clicked!", 0
dragmsg	db "You dragged the mouse", 0

upmsg	db "up  ", 0
downmsg	db "down", 0
numout	db 20 dup(?)
numfmt	db "%5d", 0

mousebtnhandle		HWND ?
mousexhandle		HWND ?
mouseyhandle		HWND ?


;============================================
; CODE
;============================================
.code


start:
	INVOKE	GetModuleHandle, NULL
	MOV	InstanceHandle, EAX

	INVOKE	WinMain, InstanceHandle
	INVOKE	ExitProcess, EAX


;============================================

WinMain		PROC hInst:DWORD
LOCAL	wc:WNDCLASSEX, msg:MSG, wX:DWORD, wY:DWORD, wWidth:DWORD, wHt:DWORD
LOCAL	brush:HBRUSH, gpRect:RECT

; Create  brush to set background color:
	INVOKE	CreateSolidBrush, BkColor
	MOV	brush, EAX

; Register class for parent window:
	MOV	wc.cbSize, SIZEOF WNDCLASSEX
	MOV	wc.style,  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	MOV	wc.lpfnWndProc, OFFSET WindowProc
	MOV	wc.cbClsExtra, NULL
	MOV	wc.cbWndExtra, NULL
	MOV	EAX, hInst
	MOV	wc.hInstance, EAX
	MOV	EAX, brush
	MOV	wc.hbrBackground, EAX
	MOV	wc.lpszMenuName,  NULL
	MOV	wc.lpszClassName, OFFSET WindowClassName
;	INVOKE	LoadIcon, hInst, 500    ; icon ID
;	MOV	wc.hIcon, EAX
	MOV	wc.hIcon, NULL
	INVOKE	LoadCursor, NULL, IDC_ARROW
	MOV	wc.hCursor, EAX
	MOV	wc.hIconSm, 0
	INVOKE	RegisterClassEx, ADDR wc

; Now register class for child windows:
	MOV	wc.cbSize, SIZEOF WNDCLASSEX
	MOV	wc.style,  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	MOV	wc.lpfnWndProc, OFFSET ChildProc
	MOV	wc.cbClsExtra, NULL
	MOV	wc.cbWndExtra, NULL
	MOV	EAX, hInst
	MOV	wc.hInstance, EAX
	MOV	EAX, brush
	MOV	wc.hbrBackground, EAX
	MOV	wc.lpszMenuName,  NULL
	MOV	wc.lpszClassName, OFFSET MWclassName
	MOV	wc.hIcon, NULL
	INVOKE	LoadCursor, NULL, IDC_ARROW
	MOV	wc.hCursor, EAX
	MOV	wc.hIconSm, 0
	INVOKE	RegisterClassEx, ADDR wc

	INVOKE	GetSystemMetrics, SM_CXSCREEN
	MOV	EDX, $WindowWidth
	INVOKE	CenterWindow, EDX, EAX
	MOV	wX, EAX
	INVOKE	GetSystemMetrics, SM_CYSCREEN
	MOV	EDX, $WindowHeight
	INVOKE	CenterWindow, EDX, EAX
	MOV	wY, EAX

; Create our main window:

	INVOKE	CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR WindowClassName, ADDR WindowDisplayName,
		$mainWinAttrs, wX, wY, $WindowWidth, $WindowHeight,
		NULL, NULL, hInst, NULL
	MOV	WindowHandle, EAX
	INVOKE	ShowWindow, WindowHandle, SW_SHOWNORMAL

; Create the status bar:
	INVOKE	CreateStatusWindow, $SB_attrs, OFFSET NullString, WindowHandle, $statusbarID
	MOV	StatusHandle, EAX
	MOV	EDX, EAX
; Get the height of the status bar:
	INVOKE	GetWindowRect, EDX, ADDR gpRect
	MOV	EAX, gpRect.bottom
	SUB	EAX, gpRect.top
	MOV	SBheight, EAX

; Create static text:
	INVOKE	CreateStaticText, ADDR @ST_Font

; Create combobox control:
	INVOKE	CreateWindowEx, WS_EX_CLIENTEDGE, ADDR CBclassName, NULL, $CBattrs,
     		$CB_X, $CB_Y, $CBwidth, $CBheight, WindowHandle, $CBID, InstanceHandle, 0
	MOV	CBHandle, EAX

	.IF	CBHandle == 0
	INVOKE	MessageBox, WindowHandle, ADDR debugmsg5, ADDR WindowDisplayName, MB_OK
	.ENDIF
	INVOKE	ShowWindow, CBHandle, SW_SHOWNORMAL

	CALL	FindFonts

; Create child windows:
	LEA	EBX, ChildWinList
_ccw20:	CMP	DWORD PTR [EBX], 0		;Look for NULL @ end of list.
	JE	_ccw90
	PUSH	EBX
	MOV	EBX, [EBX]			;Point to child entry.
	INVOKE	CreateMobileWin, EBX
	POP	EBX
	ADD	EBX, 4				;Next list entry.
	JMP	_ccw20
_ccw90:


;============= Message loop ===================
msgloop:
	INVOKE	GetMessage, ADDR msg, NULL, 0, 0
	OR	EAX, EAX		;EAX = 0 = exit
	JZ	exit
	INVOKE	TranslateMessage, ADDR msg
	INVOKE	DispatchMessage, ADDR msg
	JMP	msgloop

exit:	MOV	EAX, msg.wParam
	RET

WinMain	ENDP

;====================================================================
; Main Window Proc
;====================================================================

WindowProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL	selectedItem[256]:BYTE, pt:POINT, gpRect:RECT

	MOV	EAX, uMsg
	CMP	EAX, WM_COMMAND
	JE	dowincmd
	CMP	EAX, WM_MOUSEMOVE
	JE	domousemove
	CMP	EAX, WM_LBUTTONUP
	JE	buttonup
;	CMP	EAX, WM_CREATE
;	JE	docreate
	CMP	EAX, WM_CLOSE
	JE	doclose
	CMP	EAX, WM_SIZE
	JE	dosize
	JMP	SHORT dodefault

dowincmd:
	MOV	EDX, wParam
	SHR	EDX, 16				;High word--> low word
	CMP	DX, CBN_SELCHANGE		;See if user opened combo box
	JE	cbopen
docreate:
dodefault:
; use DefWindowProc for all other messages:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
	RET

domousemove:
; First, get current mouse position (from lParam):
	MOV	EAX, lParam			;Yep, get new X & Y pos.
	MOV	EDX, EAX			;Make a copy for later
	AND	EAX, 0FFFFH			;Mask off high word
	CWDE					;Sign-extend to DWORD
	MOV	pt.x, EAX
	MOV	EAX, EDX			;Get back copy
	SHR	EAX, 16				;High word--> low word
	CWDE
	MOV	pt.y, EAX

; Display current pos:
        PUSH    EDI
        MOV	EAX, pt.x
        MOV     EDI, OFFSET StatusXpos + 3
        CALL    B2A4
        MOV	EAX, pt.y
        MOV	EDI, OFFSET StatusYpos + 3
        CALL    B2A4
        INVOKE  SendMessage, StatusHandle, SB_SETTEXT, 0, offset StatusMessage
        POP     EDI

	CMP	MouseCaptured, TRUE		;Are we watching the mouse?
	JE	dm10				;Yes, move child window.
	CMP	DragFlag, TRUE			;No; did child report dragging?
	JNE	dodefault			;Nope, do nothing.
	MOV	DragFlag, FALSE			;Clear flag
	MOV	MouseCaptured, TRUE
	INVOKE	SetCapture, hWin
	INVOKE	GetClipCursor, ADDR PrevRect	;Get current clip rectangle
	INVOKE	GetWindowRect, hWin, ADDR gpRect
; Adjust clipping rectangle to exclude status bar:
	MOV	EAX, SBheight
	SUB	gpRect.bottom, EAX
 	INVOKE	ClipCursor, ADDR gpRect
	XOR	EAX, EAX
	RET

;Move the child window:
dm10:	INVOKE	MoveWindow, ChildHandle, pt.x, pt.y, $childWidth, $childHeight, TRUE
	INVOKE	InvalidateRect, ChildHandle, NULL, TRUE
	XOR	EAX, EAX
	RET

buttonup:
	CMP	MouseCaptured, TRUE		;Are we watching the mouse?
	JNE	dodefault			;Nope.
	INVOKE	ReleaseCapture			;Yep, stop capture.
 	INVOKE	ClipCursor, ADDR PrevRect	;Un-clip to our window.
	INVOKE	SetWindowText, mousebtnhandle, ADDR upmsg
	MOV	MouseCaptured, FALSE		;Clear flag.
	JMP	dodefault

cbopen:
	INVOKE	SendMessage, lParam, CB_GETCURSEL, 0, 0	;Get index to current selection
	MOV	EDX, EAX			;Copy index to another register
	INVOKE	SendMessage, lParam, CB_GETLBTEXT, EDX, ADDR selectedItem
	INVOKE	MessageBox, WindowHandle, ADDR selectedItem, ADDR WindowDisplayName, MB_OK
	JMP	dodefault

doclose:
	INVOKE	PostQuitMessage, NULL
	MOV	EAX, TRUE
	RET

dosize:
	INVOKE	GetClientRect, hWin, ADDR gpRect
	MOV	EDX, gpRect.bottom
	SUB	EDX, gpRect.top
	SUB	EDX, SBheight
	INVOKE	MoveWindow, StatusHandle, 0,  EDX, gpRect.right, SBheight, TRUE
	XOR	EAX, EAX
	RET

WindowProc	ENDP



;====================================================================
; Child Window Proc
;
; Handles tracking (detecting when user clicks & drags) and painting
; for all child windows. Incoming handle is matched against a list of
; child windows, and the result used to set the appropriate text.
;====================================================================

ChildProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL	pt:POINT, paintStruct:PAINTSTRUCT, paintRect:RECT, hDC:HDC


	MOV	EAX, uMsg
	CMP	EAX, WM_LBUTTONDOWN
	JE	lbuttondown
	CMP	EAX, WM_LBUTTONUP
	JE	lbuttonup
	CMP	EAX, WM_PAINT
	JE	childpaint
	
cddodef:
; use DefWindowProc for all other messages:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
cp999:	RET

lbuttondown:
	INVOKE	SetWindowText, mousebtnhandle, ADDR downmsg
; Left button down: see if user dragged:
	MOV	EAX, lParam
	MOV	EDX, EAX			;Make a copy for later
	AND	EAX, 0FFFFH			;Mask off high word
	MOV	pt.x, EAX
	SHR	EDX, 16				;High word--> low word
	MOV	pt.y, EDX
	INVOKE	DragDetect, hWin, EAX, EDX
	OR	EAX, EAX			;Did we detect dragging?
	JZ	cp999
	MOV	DragFlag, TRUE			;Yes, set flag for parent to check.
	MOV	EAX, hWin			;Copy child handle to global var.
	MOV	ChildHandle, EAX
	JMP	cp999				;Exit

lbuttonup:
	CMP	MouseCaptured, TRUE		;Are we watching the mouse?
	JNE	cddodef				;Nope.
	INVOKE	ReleaseCapture
 	INVOKE	ClipCursor, ADDR PrevRect	;Un-clip to our window.
	INVOKE	SetWindowText, mousebtnhandle, ADDR upmsg
	MOV	MouseCaptured, FALSE		;Clear flag.
	JMP	cddodef

childpaint:
;	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam	;THIS MADE THINGS WORSE (no text painted)

; Determine which text to place depending on which child is active:
	INVOKE	BeginPaint, hWin, ADDR paintStruct
	MOV	hDC, EAX			;Save handle to DC
	MOV	EAX, hWin
	PUSH	EBX
	CALL	FindChild			;Sets EBX--> child structure
	PUSH	ESI
	MOV	ESI, [EBX + $CW.text]		;Point to text to put.
        INVOKE	GetClientRect, hWin, ADDR paintRect
	INVOKE	DrawText, hDC, ESI, -1, ADDR paintRect, DT_SINGLELINE or DT_CENTER or DT_VCENTER
	INVOKE	EndPaint, hDC, ADDR paintStruct
	POP	ESI
	POP	EBX
	XOR	EAX,  EAX			;Return FALSE.
	RET


ChildProc	ENDP



CenterWindow	PROC wDim:DWORD, sDim:DWORD
; Centers window in both X and Y dimensions

	SHR	sDim, 1				;divide screen dimension by 2
	SHR	wDim, 1				;divide window dimension by 2
	MOv	EAX, sDim
	SUB	EAX, wDim			;subtract half window dimension from half screen dimension
	RET					;Return w/# in EAX

CenterWindow	ENDP


; Callback function for EnumFontFamiliesEx:
FontEnumProc	PROC	lfptr:DWORD, tmptr:DWORD, ft:DWORD, lParam:DWORD

	MOV	EBX, lfptr
	LEA	EBX, [EBX + LOGFONT.lfFaceName]
; Add name of font to combo box:
	INVOKE	SendMessage, CBHandle, CB_ADDSTRING, 0, EBX
; Indicate we want to keep on goin':
	MOV	EAX, 1
	RET

FontEnumProc	ENDP


FindFonts	PROC
	LOCAL	myDC:DWORD

	INVOKE	GetDC, WindowHandle
	MOV	myDC, EAX
; Set up fields in LOGFONT structure:
	XOR	AX, AX
	MOV	MyLF.lfCharSet, AL
	MOV	MyLF.lfFaceName, AL
	INVOKE	EnumFontFamiliesEx, myDC, ADDR MyLF, ADDR FontEnumProc, 0, 0
	INVOKE	SendMessage, CBHandle, CB_SETCURSEL, 0, 0
	INVOKE	ReleaseDC, WindowHandle, myDC
	RET

FindFonts	ENDP


CreateStaticText	PROC	 stPtr:DWORD
; Returns window handle in EAX.

	MOV	EBX, stPtr
	INVOKE	CreateWindowEx, WS_EX_LEFT, ADDR STclassName, [EBX + $ST.text], $STattrs,
     		[EBX + $ST.X], [EBX + $ST.Y],
		[EBX + $ST.w], [EBX + $ST.h], WindowHandle,
		[EBX + $ST.ID], InstanceHandle, 0
	RET

CreateStaticText	ENDP


;====================================================================
; CreateMobileWin
;
; Creates child windows
;
; On entry:
;	cwPTR:	Pointer to entry in child-window list
;
;====================================================================

CreateMobileWin	PROC	cwPtr:DWORD
LOCAL	hDC:HDC, paintStruct:PAINTSTRUCT, paintRect:RECT

	PUSH	EBX
	MOV	EBX, cwPtr
	INVOKE	CreateWindowEx, WS_EX_WINDOWEDGE, ADDR MWclassName, NULL, $childAttrs,
     		[EBX + $CW.X], [EBX + $CW.Y], $childWidth, $childHeight,
		WindowHandle, [EBX + $CW.ID], InstanceHandle, 0
	MOV	[EBX + $CW.handle], EAX			;Store handle.
	INVOKE	UpdateWindow, EAX			;Force child wndproc to paint window.
	POP	EBX
	RET

CreateMobileWin	ENDP


;====================================================================
; FindChild
;
; On entry,
;	EAX = handle to match	
;	EBX--> start of child list
;
; On exit,
;	EBX--> child structure matching handle
;====================================================================

FindChild	PROC
	PUSH	ESI
	LEA	EBX, ChildWinList
; Check next entry:
fc20:	MOV	ESI, [EBX]
	CMP	DWORD PTR[ESI], 0			;Look for NULL @ end.
	JE	fcXX					;Found it--ERROR.
	CMP	[ESI + $CW.handle], EAX			;Compare handles.
	JE	fcFound					;Found it, exit.
	ADD	BX, 4					;Next entry in list
	JMP	fc20

fcFound:	
	MOV	EBX, ESI				;Return w/pointer to child entry.
fc999:	POP	ESI
	RET

; Exit w/error:
fcXX:	XOR	EBX, EBX				;Fell through loop = ERROR.
	JMP	fc999
	
FindChild	ENDP


;====================================================================
; B2A4
;
; Converts binary value to ASCII numeric digits (4 digits, limited to
; maximum value of 9999). Result is leading-zero suppressed.
;
; On entry,
;	EAX = value to convert
;	EDI--> place to store digits (4)
; 
; Return value: (none)
;
;====================================================================

B2A4		PROC
        MOV	ECX, 4				;4 digits

b2a10:	PUSH	ECX
	MOV	ECX, 10
	XOR	EDX, EDX
	DIV	ECX
	OR	DL, '0'				;Binary--> ASCII
	POP	ECX
	MOV	[EDI], DL
	DEC	EDI
	LOOP	b2a10
; Now do leading-zero suppression:
	MOV	ECX, 3				;Look @ 1st 3 digits
b2a20:	INC	DI
	CMP	BYTE PTR [EDI], '0'
	JNE	b2a499				;Stop on 1st non-zero digit.
	MOV	BYTE PTR [EDI], ' '
	LOOP	b2a20
b2a499:	RET

B2A4		ENDP


	END	start
